/*
 * encoded charset system
 */

typedef struct _ecs *_ecs_t;
typedef struct _ecs_class *_ecs_class_t;
/* cast methods with static type-checking */

/* any object to core object */
#define _I18nOToECS(i)      ((void)_I18nClassOf(i),(struct _ecs *)(i))
/* any class object to core class object */
#define _I18nCToECSClass(c) ((void)(c)->ccore,(struct _ecs_class *)(c))


/* templates */
#define _I18n_T_Fields__ecs_class_part(n,f,v) \
	f(n,_ecs_t,	create,(_ecs_class_t)) \
	f(n,char *,	csid_to_name,(_ecs_class_t, csid_t)) \
	f(n,int,	name_to_csid,(_ecs_class_t, char *, csid_t *)) \
	f(n,void,	delete,(_ecs_t)) \
	f(n,void,	reset,(_ecs_t)) \
	f(n,int,	save,(_ecs_t, csi_mbstate_t *)) \
	f(n,int,	unsave,(_ecs_t, csi_mbstate_t *)) \
	f(n,int,	mb_to_wc,(_ecs_t, char **, size_t *, csi_wc_t *,int)) \
	f(n,int,	mb_to_cs,(_ecs_t, char **, size_t *, \
					csid_t *, csi_index_t *, int)) \
	f(n,int,	wc_to_cs,(_ecs_t, csi_wc_t, csid_t *, csi_index_t *)) \
	f(n,size_t,	wc_to_mb,(_ecs_t, csi_wc_t, char **, size_t *, int)) \
	f(n,size_t,	cs_to_mb,(_ecs_t, csid_t, csi_index_t, \
					char **, size_t *, int)) \
	f(n,int,	cs_to_wc,(_ecs_t, csid_t, csi_index_t, csi_wc_t *)) \

#define _ECS_OPT_NONE		0x00000000
#define _ECS_OPT_RESTART	0x00000001

#define _I18n_T_Rec__ecs(f) \
	_I18n_T_Rec__i18n_core(f)
#define _I18n_T_Rec__ecs_class(f) \
	_I18n_T_Rec__i18n_core_class(f) \
	f(_ecs_class,cecs)

_I18n_T_DefRec(_ecs);
_I18n_T_DeclCookie(_ecs);

_I18n_T_DefPart(_ecs_class,cecs);
_I18n_T_DefRec(_ecs_class);

_I18n_T_DeclRec(_ecs_class);

/* end of file */
