#include <stdlib.h>
#include <i18n/i18n_types.h>
#include <i18n/i18n_debug.h>
#include <i18n/i18n_class.h>
#include <i18n/i18n_static.h>
#include <i18n/i18n_alloc.h>

_i18n_object_t
_i18n_alloc_object(_i18n_class_t c, size_t size)
{
	_i18n_class_t self=_I18nOToClass(c);
	_i18n_object_t ret;

	ret = (_i18n_object_t)malloc(size);
	if (ret) {
		_I18nClassOf(ret) = self;
		_I18nRef(self);
		_I18nRef(ret);
	}

	return ret;
}

void
_i18n_free_object(_i18n_object_t o)
{
	_I18nUnref(_I18nClassOf(o));
	free(o);
}

#define _D_core_klass		_I18nGetClass(_i18n_static_class)
#define _D_core_refCount	0
#define _D_core_dynamic		NULL
#define _D_ccore_super		NULL
#define _D_ccore_cookie		_I18nGetCookie(_i18n_core)
#define _D_ccore_release	&_i18n_free_object
_I18n_T_FillRec(_i18n_allocated_class);

/* end of file */
