/*
 * debug
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <i18n/i18n_types.h>
#include <i18n/i18n_debug.h>

void
_i18n_dpr(char const *format, ...)
{
	va_list ap;
	va_start(ap, format);
	if (getenv("I18N_DEBUG"))
		vfprintf(stderr, format, ap);
	va_end(ap);
}

void
_i18n_assert(char const *file, int line, char const *cond)
{
	if (getenv("I18N_DEBUG")) {
		fprintf(stderr, "ASSERT(%s:%d): %s\n", file, line, cond);
		abort();
	}
}

/* end of file */
